// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.pmfm;

/**
 * <p>
 * Niveau (ou période) d'agrégation de la donnée.
 * </p>
 * <p>
 * Par exemple :
 * </p>
 * <p>
 * - aucune (pas d'agrégation)
 * </p>
 * <p>
 * - jour,
 * </p>
 * <p>
 * - mois,
 * </p>
 * <p>
 * - année
 * </p>
 * <p>
 * - marée
 * </p>
 * <p>
 * - opération
 * </p>
 * <p>
 * - zone de peche (cas des séquences de peche ?)
 * </p>
 * <p>
 * Utiliser une période d'agrégation permet de définir des valeurs
 * moyennes sur une période d'agrégation (par exemple : le mois)
 * indépendamment de la période concernée (par exemple : une
 * année).
 * </p>
 * <p>
 * Exemple :
 * </p>
 * <p>
 * - moyenne mensuelle sur l'année, du nombre d'engin levé par jour
 * :
 * </p>
 * <p>
 * - paramètre : nombre d'engin levé
 * </p>
 * <p>
 * - niveau d'agrégation du PSFM : jour
 * </p>
 * <p>
 * - période concerné : 01/01/XX au 31/12/XX : définie au niveau de
 * l'entité à laquelle est rattachée la mesure (exemple : la marée,
 * l'opération, les caractéristiques d'utilisation, etc.).
 * </p>
 * <p>
 * - période d'agrégation sur la mesure (xxxMeasurement) : mois
 * </p>
 */
public abstract class AggregationLevel
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -5347810867364996451L;

    private java.lang.Integer id;

    /**
     * <p>
     * Idenfiant interne. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String name;

    /**
     * 
     */
    public java.lang.String getName()
    {
        return this.name;
    }

    public void setName(java.lang.String name)
    {
        this.name = name;
    }

    private java.lang.Integer rankOrder;

    /**
     * <p>
     * rang permettant de classer les niveau d'agrégation par ordre de
     * précision : le niveau le plus bas est 'aucune' (donnée brute),
     * le niveau le plus haut pourrait etre 'année' (moyenne annuelle)
     * </p>
     */
    public java.lang.Integer getRankOrder()
    {
        return this.rankOrder;
    }

    public void setRankOrder(java.lang.Integer rankOrder)
    {
        this.rankOrder = rankOrder;
    }

    private java.sql.Timestamp updateDate;

    /**
     * 
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }



    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof AggregationLevel))
        {
            return false;
        }
        final AggregationLevel that = (AggregationLevel)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel}.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel entity = new fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevelImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel newInstance(java.lang.String name, java.lang.Integer rankOrder)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel entity = newInstance();
            entity.setName(name);
            entity.setRankOrder(rankOrder);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel newInstance(java.lang.String name, java.lang.Integer rankOrder, java.sql.Timestamp updateDate)
        {
            final fr.ifremer.adagio.core.dao.referential.pmfm.AggregationLevel entity = newInstance();
            entity.setName(name);
            entity.setRankOrder(rankOrder);
            entity.setUpdateDate(updateDate);
            return entity;
        }
    }
    
// AggregationLevel.java merge-point
}