// license-header java merge-point
//
// Attention: Generated code! Do not modify by hand!
// Generated by: HibernateEntity.vsl in andromda-hibernate-cartridge.
//
package fr.ifremer.adagio.core.dao.referential.taxon;

/**
 * <p>
 * Les documents de référence sont tous les documents qui peuvent
 * apporter des informations relatives à la classification
 * systématique des taxons (nomenclature, description, synonymie)
 * ou à la définition des groupes de taxons. Ces documents peuvent
 * être des publications officielles (articles de revues ou
 * ouvrage), ou bien des notes de laboratoire, rapports internes,
 * etc.
 * </p>
 * <p>
 * Dans le cas des publications, la référence du document permet de
 * retrouver les sources. En revanche, pour les notes de labo,
 * documents internes, et autres, il faudra préciser dans la
 * référence la localisation de la source (quel service ou quel
 * labo, quelle personne de référence pour se le procurer).
 * </p>
 * <p>
 * Les références des publications doivent respecter les règles
 * d'édition des bibliographies (Auteurs, date. Titre. Editeur...).
 * </p>
 */
public abstract class ReferenceDocument
    implements java.io.Serializable
{
    /**
     * The serial version UID of this class. Needed for serialization.
     */
    private static final long serialVersionUID = -1529010323374173007L;

    private java.lang.Integer id;

    /**
     * <p>
     * Identifiant unique du document. Généré par le système.
     * </p>
     */
    public java.lang.Integer getId()
    {
        return this.id;
    }

    public void setId(java.lang.Integer id)
    {
        this.id = id;
    }

    private java.lang.String reference;

    /**
     * <p>
     * Libellé stockant la référence du document. Ceci peut être le
     * nom, l'édition etc.
     * </p>
     */
    public java.lang.String getReference()
    {
        return this.reference;
    }

    public void setReference(java.lang.String reference)
    {
        this.reference = reference;
    }

    private java.util.Date publicationDate;

    /**
     * <p>
     * Date de parution du document.
     * </p>
     */
    public java.util.Date getPublicationDate()
    {
        return this.publicationDate;
    }

    public void setPublicationDate(java.util.Date publicationDate)
    {
        this.publicationDate = publicationDate;
    }

    private java.lang.String comments;

    /**
     * <p>
     * Commentaires divers associés au document de référence.
     * </p>
     */
    public java.lang.String getComments()
    {
        return this.comments;
    }

    public void setComments(java.lang.String comments)
    {
        this.comments = comments;
    }

    private java.util.Date creationDate;

    /**
     * <p>
     * Date de création système du document de référence. Renseigné
     * automatiquement par le système.
     * </p>
     */
    public java.util.Date getCreationDate()
    {
        return this.creationDate;
    }

    public void setCreationDate(java.util.Date creationDate)
    {
        this.creationDate = creationDate;
    }

    private java.sql.Timestamp updateDate;

    /**
     * <p>
     * Date de mise à jour système de la référence. Renseigné
     * automatiquement par le système.
     * </p>
     */
    public java.sql.Timestamp getUpdateDate()
    {
        return this.updateDate;
    }

    public void setUpdateDate(java.sql.Timestamp updateDate)
    {
        this.updateDate = updateDate;
    }


    private fr.ifremer.adagio.core.dao.referential.Status status;

    /**
     * 
     */
    public fr.ifremer.adagio.core.dao.referential.Status getStatus()
    {
        return this.status;
    }

    public void setStatus(fr.ifremer.adagio.core.dao.referential.Status status)
    {
        this.status = status;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonInformationHistory> taxonInformationHistories = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.TaxonInformationHistory>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonInformationHistory> getTaxonInformationHistories()
    {
        return this.taxonInformationHistories;
    }

    public void setTaxonInformationHistories(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonInformationHistory> taxonInformationHistories)
    {
        this.taxonInformationHistories = taxonInformationHistories;
    }


    private java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.Author> authors = new java.util.HashSet<fr.ifremer.adagio.core.dao.referential.taxon.Author>();

    /**
     * 
     */
    public java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.Author> getAuthors()
    {
        return this.authors;
    }

    public void setAuthors(java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.Author> authors)
    {
        this.authors = authors;
    }



    /**
     * This entity does not have any identifiers
     * and is not extending any other entity,
     * so this method will only return <code>true</code> if the argument reference and <code>this</code>
     * refer to the same object.
     */
    public boolean equals(Object object)
    {
        if (this == object)
        {
            return true;
        }
        if (!(object instanceof ReferenceDocument))
        {
            return false;
        }
        final ReferenceDocument that = (ReferenceDocument)object;
        if (this.id == null || that.getId() == null || !this.id.equals(that.getId()))
        {
            return false;
        }
        return true;
    }

    /**
     * Returns a hash code based on this entity's identifiers.
     */
    public int hashCode()
    {
        int hashCode = 0;
        hashCode = 29 * hashCode + (id == null ? 0 : id.hashCode());

        return hashCode;
    }

    /**
     * Constructs new instances of {@link fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument}.
     */
    public static final class Factory
    {
        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument}.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument newInstance()
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument entity = new fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocumentImpl();
			return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument}, taking all required and/or
         * read-only properties as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument newInstance(java.lang.String reference, java.util.Date creationDate, fr.ifremer.adagio.core.dao.referential.Status status, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.Author> authors)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument entity = newInstance();
            entity.setReference(reference);
            entity.setCreationDate(creationDate);
            entity.setStatus(status);
            entity.setAuthors(authors);
            return entity;
        }

        /**
         * Constructs a new instance of {@link fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument}, taking all possible properties
         * (except the identifier(s))as arguments.
         */
        public static fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument newInstance(java.lang.String reference, java.util.Date publicationDate, java.lang.String comments, java.util.Date creationDate, java.sql.Timestamp updateDate, fr.ifremer.adagio.core.dao.referential.Status status, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.TaxonInformationHistory> taxonInformationHistories, java.util.Collection<fr.ifremer.adagio.core.dao.referential.taxon.Author> authors)
        {
            final fr.ifremer.adagio.core.dao.referential.taxon.ReferenceDocument entity = newInstance();
            entity.setReference(reference);
            entity.setPublicationDate(publicationDate);
            entity.setComments(comments);
            entity.setCreationDate(creationDate);
            entity.setUpdateDate(updateDate);
            entity.setStatus(status);
            entity.setTaxonInformationHistories(taxonInformationHistories);
            entity.setAuthors(authors);
            return entity;
        }
    }
    
// ReferenceDocument.java merge-point
}